package com.jz.dmp.modules.controller.bean;

import java.util.ArrayList;
import java.util.List;

import org.springframework.beans.BeanUtils;
import com.jz.dmp.modules.controller.projconfig.bean.DmpProjectConfigEngineDto;
import com.jz.dmp.modules.model.DmpProjectConfigEngine;
import com.jz.dmp.modules.model.DmpProjectEngineParam;

public class MyDmpProjectConfigEngineConverter {
	
	private static MyDmpProjectConfigEngineConverter instance;
	
	private MyDmpProjectConfigEngineConverter() {};
	
	public synchronized static MyDmpProjectConfigEngineConverter INSTANCE() {
		if (instance==null) {
			instance = new MyDmpProjectConfigEngineConverter();
		}
		
		return instance;
	}
	
	public DmpProjectConfigEngineDto domain2dto(DmpProjectConfigEngine dmpProjectConfigEngine) {
		DmpProjectConfigEngineDto dmpProjectConfigEngineDto = new DmpProjectConfigEngineDto();
		BeanUtils.copyProperties(dmpProjectConfigEngine, dmpProjectConfigEngineDto);
		
		return dmpProjectConfigEngineDto;
	}
	
	public List<DmpProjectConfigEngineDto> domain2dto(List<DmpProjectConfigEngine> dmpProjectConfigEngines) {
		List<DmpProjectConfigEngineDto> dmpProjectConfigEngineDtos = new ArrayList<DmpProjectConfigEngineDto>();
		dmpProjectConfigEngines.stream().forEach(x -> {
			dmpProjectConfigEngineDtos.add(domain2dto(x));
		});
		
		return dmpProjectConfigEngineDtos;
	}
	
	public DmpProjectConfigEngine dto2domain(DmpProjectConfigEngineDto dmpProjectConfigEngineDto) {
		DmpProjectConfigEngine dmpProjectConfigEngine = new DmpProjectConfigEngine();
		List<DmpProjectEngineParam> dmpProjectEngineParams = dmpProjectConfigEngineDto.getDmpProjectEngineParams();
		BeanUtils.copyProperties(dmpProjectConfigEngineDto, dmpProjectConfigEngine);
		dmpProjectConfigEngine.setDmpProjectEngineParams(dmpProjectEngineParams);
		
		return dmpProjectConfigEngine;
	}
	
	public List<DmpProjectConfigEngine> dto2domain(List<DmpProjectConfigEngineDto> dmpProjectConfigEngineDtos) {
		List<DmpProjectConfigEngine> dmpProjectConfigEngines = new ArrayList<DmpProjectConfigEngine>();
		dmpProjectConfigEngineDtos.stream().forEach(x -> {
			dmpProjectConfigEngines.add(dto2domain(x));
		});
		
		return dmpProjectConfigEngines;
	}

}
